<template>
  <div class="detail container">
    <div class="d-flex flex-grow-1 flex-row py-4">
      <img src="@/assets/images/logo-ipma.png"/>
    </div>
    <div class="d-flex flex-grow-1 flex-column">
      <h2>Informação do local</h2>
      <table class="table text-center">
        <thead>
          <tr>
            <th scope="col">Latitude</th>
            <th scope="col">Longitude</th>
            <th scope="col">Data de atualização</th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>{{ $route.params.latitude }}</td>
            <td>{{ $route.params.longitude }}</td>
            <td>{{ referenceTimeStr }}</td>
          </tr>
        </tbody>
      </table>
    </div>
    <div class="detail-plot-group d-flex flex-grow-1 flex-column">
      <h2>Dados da estação</h2>
      <div class="d-flex flex-grow-1 flex-column">
        <h4>Temperatura</h4>
        <station-plot-area :plot-variables="temperaturePlot"/>
      </div>
      <div class="d-flex flex-grow-1 flex-column">
        <h4>Humidade relativa</h4>
        <station-plot-area :plot-variables="humidityPlot"/>
      </div>
      <div class="d-flex flex-grow-1 flex-column">
        <h4>Pressão</h4>
        <station-plot-area :plot-variables="pressurePlot"/>
      </div>
      <div class="d-flex flex-grow-1 flex-column">
        <h4>Precipitação</h4>
        <station-plot-area :plot-variables="precipitationPlot"/>
      </div>
    </div>
    <div v-for="group in settings" :key="group.title" class="detail-plot-group d-flex flex-grow-1 flex-column">
      <h2>{{ group.title }}</h2>
      <div v-for="plot in group.plots" :key="`${group.title}-${plot.title}`" class="d-flex flex-grow-1 flex-column">
        <h4>{{ plot.title }}</h4>
        <details-plot-area
         :reference-time="referenceTime"
         :latitude="parseFloat($route.params.latitude)"
         :longitude="parseFloat($route.params.longitude)"
         :plot-variables="plot.variables"/>
      </div>
    </div>
  </div>
</template>

<script>
import moment from 'moment'
import DetailsPlotArea from '@/detail/components/DetailsPlotArea'
import StationPlotArea from '@/detail/components/StationPlotArea'
import settings from '@/detail/data/settings'

export default {
  name: 'DetailStation',

  data() {
    return {
      stationData: null,
      loading: true,
      error: null,
    }
  },

  computed: {
    referenceTime: {
      get() {
        return moment.unix(this.$route.params.datetime).unix()
      }
    },

    referenceTimeStr: {
      get() {
        return moment.unix(this.$route.params.datetime).format('YYYY-MM-DD HH:mm')
      }
    },

    settings: {
      get() {
        return settings
      }
    },

    temperaturePlot: {
      get() {
        return [{
          name: 'temperature-maximum',
          title: 'Temperatura máxima',
          axis: 'temperature-axis',
          settings: {
            order: 2,
            type: 'line',
            label: 'Temperatura máxima',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#fa0000',
            yAxisID: 'temperature-axis'
          }
        }, {
          name: 'temperature-minimum',
          axis: 'temperature-axis',
          title: 'Temperatura mínima',
          settings: {
            order: 2,
            type: 'line',
            label: 'Temperatura mínima',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#fa0000',
            yAxisID: 'temperature-axis'
          }
        }, {
          name: 'temperature-mean',
          axis: 'temperature-axis',
          title: 'Temperatura média',
          settings: {
            order: 2,
            type: 'line',
            label: 'Temperatura média',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#fa0000',
            yAxisID: 'temperature-axis'
          }
        }]
      }
    },

    humidityPlot: {
      get () {
        return [{
          name: 'relative-humidity-minimum',
          axis: 'humidity-axis',
          title: 'Humidade relativa mínima',
          settings: {
            order: 2,
            type: 'line',
            label: 'Humidade relativa mínima',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#0000fa',
            yAxisID: 'humidity-axis'
          }
        }, {
          name: 'relative-humidity-maximum',
          axis: 'humidity-axis',
          title: 'Humidade relativa máxima',
          settings: {
            order: 2,
            type: 'line',
            label: 'Humidade relativa máxima',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#0000fa',
            yAxisID: 'humidity-axis'
          }
        }, {
          name: 'relative-humidity-mean',
          axis: 'humidity-axis',
          title: 'Humidade relativa média',
          settings: {
            order: 2,
            type: 'line',
            label: 'Humidade relativa média',
            backgroundColor: 'rgba(0, 0, 0, 0)',
            borderColor: '#0000fa',
            yAxisID: 'humidity-axis'
          }
        }]
      }
    },

    pressurePlot: {
      get () {
        return [{
          name: 'pressure',
          title: 'Pressão',
          axis: 'pressure-axis',
          settings: {
            order: 2,
            type: 'line',
            fill: 'start',
            label: 'Pressão ao N.M.M.',
            backgroundColor: 'rgba(30, 90, 130, 0.45)',
            borderColor: 'rgba(30, 90, 130, 0.45)',
            pointRadius: 0,
            yAxisID: 'pressure-axis'
          }
        }]
      }
    },

    precipitationPlot: {
      get () {
        return [{
          name: 'precipitation',
          axis: 'precipitation-axis',
          title: 'Precipitação',
          settings: {
            order: 2,
            type: 'bar',
            label: 'Precipitação',
            backgroundColor: 'rgba(112, 172, 196, 200)',
            borderColor: 'rgba(112, 172, 196, 200)',
            yAxisID: 'precipitation-axis',
          }
        }, {
          name: 'precipitation-maximum',
          axis: 'precipitation-axis',
          title: 'Precipitação máxima',
          settings: {
            order: 2,
            type: 'bar',
            label: 'Precipitação máxima',
            backgroundColor: 'rgba(112, 172, 196, 200)',
            borderColor: 'rgba(112, 172, 196, 200)',
            yAxisID: 'precipitation-axis',
          }
        }]
      }
    }
  },

  components: {
    DetailsPlotArea,
    StationPlotArea,
  },
}
</script>
